Fix error when OPENMANO envioronment is set a different location
[osm/RO.git] / test / basictest.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #This script can be used as a basic test of openmano.
25 #WARNING: It destroy the database content
26
27
28 function usage(){
29 echo -e "usage: ${BASH_SOURCE[0]} [OPTIONS] <action>\n test openmano using openvim as a VIM"
30 echo -e " the OPENVIM_HOST, OPENVIM_PORT shell variables indicate openvim location"
31 echo -e " by default localhost:9080"
32 echo -e " <action> is a list of the following items (by default 'reset create delete')"
33 echo -e " reset reset the openmano database content"
34 echo -e " create creates items"
35 echo -e " delete delete created items"
36 echo -e " OPTIONS:"
37 echo -e " -f --force does not prompt for confirmation"
38 echo -e " -h --help shows this help"
39 echo -e " --insert-bashrc insert the created tenant,datacenter variables at"
40 echo -e " ~/.bashrc to be available by openmano CLI"
41 echo -e " --init-openvim if openvim runs locally, an init is called to clean openvim"
42 echo -e " database and add fake hosts"
43 }
44
45 function is_valid_uuid(){
46 echo "$1" | grep -q -E '^[0-9a-f]{8}-([0-9a-f]{4}-){3}[0-9a-f]{12}$' && return 0
47 return 1
48 }
49
50 #detect if is called with a source to use the 'exit'/'return' command for exiting
51 [[ ${BASH_SOURCE[0]} != $0 ]] && _exit="return" || _exit="exit"
52
53
54 #check correct arguments
55 force=""
56 action_list=""
57 insert_bashrc=""
58 init_openvim=""
59 for param in $*
60 do
61 if [[ $param == reset ]] || [[ $param == create ]] || [[ $param == delete ]]
62 then
63 action_list="$action_list $param"
64 elif [[ $param == -h ]] || [[ $param == --help ]]
65 then
66 usage
67 $_exit 0
68 elif [[ $param == -f ]] || [[ $param == --force ]]
69 then
70 force="-f"
71 elif [[ $param == --insert-bashrc ]]
72 then
73 insert_bashrc=y
74 elif [[ $param == --init-openvim ]]
75 then
76 init_openvim=y
77 else
78 echo "invalid argument '$param'? Type -h for help" >&2 && $_exit 1
79 fi
80 done
81
82 DIRNAME=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
83 DIRmano=$(dirname $DIRNAME)
84 DIRscript=${DIRmano}/scripts
85 export OPENMANO_HOST=localhost
86 export OPENMANO_PORT=9090
87 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_HOST=localhost" >> ~/.bashrc
88 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_PORT=9090" >> ~/.bashrc
89
90
91 #by default action should be reset and create
92 [[ -z $action_list ]] && action_list="reset create delete"
93 [[ -z $init_openvim ]] || initopenvim $force || echo "WARNING openvim cannot be initialized. The rest of test can fail!"
94
95 #check openvim client variables are set
96 #fail=""
97 #[[ -z $OPENVIM_HOST ]] && echo "OPENVIM_HOST variable not defined" >&2 && fail=1
98 #[[ -z $OPENVIM_PORT ]] && echo "OPENVIM_PORT variable not defined" >&2 && fail=1
99 #[[ -n $fail ]] && $_exit 1
100
101
102 for action in $action_list
103 do
104 #if [[ $action == "install-openvim" ]]
105 #echo "Installing and starting openvim"
106 #mkdir -p temp
107 #pushd temp
108 #wget https://github.com/nfvlabs/openvim/raw/v0.4/scripts/install-openvim.sh
109 #chmod -x install-openvim.sh
110 #fi
111
112 if [[ $action == "reset" ]]
113 then
114
115 #ask for confirmation if argument is not -f --force
116 force_=y
117 [[ -z $force ]] && read -e -p "WARNING: reset openmano database, content will be lost!!! Continue(y/N) " force_
118 [[ $force_ != y ]] && [[ $force_ != yes ]] && echo "aborted!" && $_exit
119
120 echo "Stopping openmano"
121 $DIRscript/service-openmano.sh mano stop
122 echo "Initializing openmano database"
123 $DIRmano/database_utils/init_mano_db.sh -u mano -p manopw
124 echo "Starting openmano"
125 $DIRscript/service-openmano.sh mano start
126 echo
127
128 elif [[ $action == "delete" ]]
129 then
130 result=`openmano tenant-list TEST-tenant`
131 nfvotenant=`echo $result |gawk '{print $1}'`
132 #check a valid uuid is obtained
133 is_valid_uuid $nfvotenant || ! echo "Tenant TEST-tenant not found. Already delete?" >&2 || $_exit 1
134 export OPENMANO_TENANT=$nfvotenant
135 ${DIRmano}/openmano instance-scenario-delete -f simple-instance || echo "fail"
136 ${DIRmano}/openmano instance-scenario-delete -f complex-instance || echo "fail"
137 ${DIRmano}/openmano instance-scenario-delete -f complex2-instance || echo "fail"
138 ${DIRmano}/openmano scenario-delete -f simple || echo "fail"
139 ${DIRmano}/openmano scenario-delete -f complex || echo "fail"
140 ${DIRmano}/openmano scenario-delete -f complex2 || echo "fail"
141 ${DIRmano}/openmano vnf-delete -f linux || echo "fail"
142 ${DIRmano}/openmano vnf-delete -f dataplaneVNF_2VMs || echo "fail"
143 ${DIRmano}/openmano vnf-delete -f dataplaneVNF2 || echo "fail"
144 ${DIRmano}/openmano vnf-delete -f dataplaneVNF3 || echo "fail"
145 ${DIRmano}/openmano datacenter-detach TEST-dc || echo "fail"
146 ${DIRmano}/openmano datacenter-delete -f TEST-dc || echo "fail"
147 ${DIRmano}/openmano tenant-delete -f TEST-tenant || echo "fail"
148 echo
149
150 elif [[ $action == "create" ]]
151 then
152 printf "%-50s" "Creating openmano tenant 'TEST-tenant': "
153 result=`${DIRmano}/openmano tenant-create TEST-tenant --description="created by basictest.sh"`
154 nfvotenant=`echo $result |gawk '{print $1}'`
155 #check a valid uuid is obtained
156 ! is_valid_uuid $nfvotenant && echo "FAIL" && echo " $result" && $_exit 1
157 export OPENMANO_TENANT=$nfvotenant
158 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_TENANT=$nfvotenant" >> ~/.bashrc
159 echo $nfvotenant
160
161 printf "%-50s" "Creating datacenter 'TEST-dc' in openmano:"
162 [[ -z $OPENVIM_HOST ]] && OPENVIM_HOST=localhost
163 [[ -z $OPENVIM_PORT ]] && OPENVIM_PORT=9080
164 URL_ADMIN_PARAM=""
165 [[ -n $OPENVIM_ADMIN_PORT ]] && URL_ADMIN_PARAM="--url_admin=http://${$OPENVIM_HOST}:${OPENVIM_ADMIN_PORT}/openvim"
166 result=`${DIRmano}/openmano datacenter-create TEST-dc "http://${OPENVIM_HOST}:${OPENVIM_PORT}/openvim" --type=openvim $URL_ADMIN_PARAM`
167 datacenter=`echo $result |gawk '{print $1}'`
168 #check a valid uuid is obtained
169 ! is_valid_uuid $datacenter && echo "FAIL" && echo " $result" && $_exit 1
170 echo $datacenter
171 export OPENMANO_DATACENTER=$datacenter
172 [[ $insert_bashrc == y ]] && echo -e "\nexport OPENMANO_DATACENTER=$datacenter" >> ~/.bashrc
173
174 printf "%-50s" "Attaching openmano tenant to the datacenter:"
175 result=`${DIRmano}/openmano datacenter-attach TEST-dc`
176 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
177 echo OK
178
179 printf "%-50s" "Updating external nets in openmano: "
180 result=`${DIRmano}/openmano datacenter-netmap-delete -f --all`
181 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
182 result=`${DIRmano}/openmano datacenter-netmap-upload -f`
183 [[ $? != 0 ]] && echo "FAIL" && echo " $result" && $_exit 1
184 echo OK
185
186 for VNF in linux dataplaneVNF1 dataplaneVNF2 dataplaneVNF_2VMs dataplaneVNF3
187 do
188 printf "%-50s" "Creating VNF '${VNF}': "
189 result=`$DIRmano/openmano vnf-create $DIRmano/vnfs/examples/${VNF}.yaml`
190 vnf=`echo $result |gawk '{print $1}'`
191 #check a valid uuid is obtained
192 ! is_valid_uuid $vnf && echo FAIL && echo " $result" && $_exit 1
193 echo $vnf
194 done
195 for NS in simple complex complex2
196 do
197 printf "%-50s" "Creating scenario '${NS}':"
198 result=`$DIRmano/openmano scenario-create $DIRmano/scenarios/examples/${NS}.yaml`
199 scenario=`echo $result |gawk '{print $1}'`
200 ! is_valid_uuid $scenario && echo FAIL && echo " $result" && $_exit 1
201 echo $scenario
202 done
203
204 for IS in simple complex complex2
205 do
206 printf "%-50s" "Creating instance-scenario '${IS}':"
207 result=`$DIRmano/openmano instance-scenario-create --scenario ${IS} --name ${IS}-instance`
208 instance=`echo $result |gawk '{print $1}'`
209 ! is_valid_uuid $instance && echo FAIL && echo " $result" && $_exit 1
210 echo $instance
211 done
212
213 echo
214 #echo "Check virtual machines are deployed"
215 #vms_error=`openvim vm-list | grep ERROR | wc -l`
216 #vms=`openvim vm-list | wc -l`
217 #[[ $vms -ne 8 ]] && echo "WARNING: $vms VMs created, must be 8 VMs" >&2 && $_exit 1
218 #[[ $vms_error -gt 0 ]] && echo "WARNING: $vms_error VMs with ERROR" >&2 && $_exit 1
219 fi
220 done
221
222 echo
223 echo DONE
224
225